# 2021-06-30 Triage Log

We only have partial results this week (more details below). From the results we have collected, we have one small regression and several improvements.
Also, there was a broad [max-rss regression](https://perf.rust-lang.org/compare.html?start=29cd70d40722930e66a8b726fe58a7bd1d64a22b&end=6b354a13820a444f834a33365ae4a8d97d7d27ce&stat=max-rss) from 11 days ago.
and narrower [max-rss regression](https://perf.rust-lang.org/compare.html?start=406d4a9cc3b9601cf98a07c6c83e0227d64f5d48&end=4573a4a879a8e1f773944a8859e4dcd136138af8&stat=max-rss) from 9 days ago.

This week we had some problems with missing benchmark results for some of the commits (we believe this is due to triagebot being out of service for a while). Thus, there is a gap from
[5a7834050f3a0ebcd117b4ddf0bc1e8459594309](https://github.com/rust-lang/rust/commit/5a7834050f3a0ebcd117b4ddf0bc1e8459594309) to [7c3872e6bfd555d2ad753ac1f871db3bd7f2a547](https://github.com/rust-lang/rust/commit/7c3872e6bfd555d2ad753ac1f871db3bd7f2a547).

The following PR's from that gap were omitted from this analysis.

 * [#86467](https://github.com/rust-lang/rust/issues/86467) - ChrisDenton:win-env-clear, r=JohnTitor
 * [#85427](https://github.com/rust-lang/rust/issues/85427) - ehuss:fix-use-placement, r=jackh726
 * [#86279](https://github.com/rust-lang/rust/issues/86279) - JohnTitor:transparent-zero-size-fields, r=nikomatsakis
 * [#86588](https://github.com/rust-lang/rust/issues/86588) - JohnTitor:rollup-ibgjbkf, r=JohnTitor
 * [#86138](https://github.com/rust-lang/rust/issues/86138) - FabianWolff:issue-85871, r=nikomatsakis
 * [#86573](https://github.com/rust-lang/rust/issues/86573) - Mark-Simulacrum:expat-bump, r=pietroalbini

We have manually enqueued the missing commits for benchmarking on perf.rlo.

Triage done by **@pnkfelix**.
Revision range: [406d4a9cc3b9601cf98a07c6c83e0227d64f5d48..5a7834050f3a0ebcd117b4ddf0bc1e8459594309](https://perf.rust-lang.org/?start=406d4a9cc3b9601cf98a07c6c83e0227d64f5d48&end=5a7834050f3a0ebcd117b4ddf0bc1e8459594309&absolute=false&stat=instructions%3Au)
Revision range: [7c3872e6bfd555d2ad753ac1f871db3bd7f2a547..7ede6e2a2359c1bb9032baffa4fdafe5633749e3](https://perf.rust-lang.org/?start=7c3872e6bfd555d2ad753ac1f871db3bd7f2a547&end=7ede6e2a2359c1bb9032baffa4fdafe5633749e3&absolute=false&stat=instructions%3Au)

1 Regressions, 5 Improvements, 0 Mixed

1 of them in rollups

#### Regressions

Disambiguate between SourceFiles from different crates even if they have the same path [#86368](https://github.com/rust-lang/rust/issues/86368)
- Moderate regression in [instruction counts](https://perf.rust-lang.org/compare.html?start=3487be11d5f3c9afc4d8e44438cdd2af1e98c859&end=80926fc409d671e7da13f08c90642b1e71f800d9&stat=instructions:u) (up to 1.2% on `incr-unchanged` builds of `ctfe-stress-4-check`)

#### Improvements

Add MIR pass to lower call to `core::slice::len` into `Len` operand [#86383](https://github.com/rust-lang/rust/issues/86383)
- Moderate improvement in [instruction counts](https://perf.rust-lang.org/compare.html?start=406d4a9cc3b9601cf98a07c6c83e0227d64f5d48&end=4573a4a879a8e1f773944a8859e4dcd136138af8&stat=instructions:u) (up to -2.9% on `incr-patched: Job` builds of `regex-debug`)

Rollup of 11 pull requests [#86527](https://github.com/rust-lang/rust/issues/86527)
- Moderate improvement in [instruction counts](https://perf.rust-lang.org/compare.html?start=4573a4a879a8e1f773944a8859e4dcd136138af8&end=2c04f0bb171bb7dc573d0da4b59960106823c2cd&stat=instructions:u) (up to -1.2% on `incr-patched: b9b3e592dd cherry picked` builds of `style-servo-debug`)

Derive `Copy` for `VarianceDiagInfo` [#86670](https://github.com/rust-lang/rust/issues/86670)
- Moderate improvement in [instruction counts](https://perf.rust-lang.org/compare.html?start=fecc65a19763364b8dafbbf1d23be562268bd387&end=47b2f15bba4544170e6e748910e7c01da467c897&stat=instructions:u) (up to -4.8% on `full` builds of `wg-grammar-check`)
- Notably, this was in response to a nag re: a regression from #85343. Thanks @**Aaron Hill**!

Add inflate to pgo [#86697](https://github.com/rust-lang/rust/issues/86697)
- Moderate improvement in [instruction counts](https://perf.rust-lang.org/compare.html?start=47b2f15bba4544170e6e748910e7c01da467c897&end=f12d91f9da9b06813b3bc0c31aa6133070ada9ab&stat=instructions:u) (up to -3.4% on `full` builds of `keccak-debug`)

Change vtable memory representation to use tcx allocated allocations. [#86475](https://github.com/rust-lang/rust/issues/86475)
- Moderate improvement in [instruction counts](https://perf.rust-lang.org/compare.html?start=8971fff984e7a45ca6cdcd146816b4896a4ab1ea&end=e98897e5dc9898707bf4331c43b2e76ab7e282fe&stat=instructions:u) (up to -1.2% on `incr-unchanged` builds of `ctfe-stress-4-check`)

#### Mixed



#### Nags requiring follow up

- Follow up on max-rss regression in [#86034](https://github.com/rust-lang/rust/pull/86034#issuecomment-871488586)
