# 2023-07-04 Triage Log

A quiet week, with a mixed set of improvements and regressions. Overall
slightly more improvements than regressions.

Triage done by **@simulacrum**.
Revision range: [b5e51db16dfbf5685e32dfe2d9a835a5c695afe4..52d8c490a3aabe65cdd9f2d3aed95034dd5dbad7](https://perf.rust-lang.org/?start=b5e51db16dfbf5685e32dfe2d9a835a5c695afe4&end=52d8c490a3aabe65cdd9f2d3aed95034dd5dbad7&absolute=false&stat=instructions%3Au)

**Summary**:

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 1.1%  | [0.3%, 2.8%]   | 46    |
| Regressions ❌ <br /> (secondary)  | 1.5%  | [0.4%, 6.9%]   | 71    |
| Improvements ✅ <br /> (primary)   | -2.0% | [-4.2%, -0.5%] | 7     |
| Improvements ✅ <br /> (secondary) | -2.5% | [-7.3%, -0.3%] | 7     |
| All ❌✅ (primary)                 | 0.7%  | [-4.2%, 2.8%]  | 53    |


2 Regressions, 3 Improvements, 2 Mixed; 0 of them in rollups

51 artifact comparisons made in total

#### Regressions

Backtrace 0.3.68 [#113176](https://github.com/rust-lang/rust/pull/113176) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=839e9a6e1210934fd24b15548b811a97c77138fc&end=571c9fc8a9693bb75822d7b46a8d3bed0388e925&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 2.2%  | [1.8%, 2.6%]   | 12    |
| Regressions ❌ <br /> (secondary)  | 1.6%  | [0.3%, 6.8%]   | 38    |
| Improvements ✅ <br /> (primary)   | -     | -              | 0     |
| Improvements ✅ <br /> (secondary) | -2.1% | [-2.1%, -2.1%] | 1     |
| All ❌✅ (primary)                 | 2.2%  | [1.8%, 2.6%]   | 12    |

Appears to be due to increases in binary size, leading to longer link times.

Rewrite `UnDerefer` [#112882](https://github.com/rust-lang/rust/pull/112882) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=571c9fc8a9693bb75822d7b46a8d3bed0388e925&end=d5a74249c843e06b502fb097ebea2383b9a5d9b8&stat=instructions:u)

| (instructions:u)                   | mean | range        | count |
|:----------------------------------:|:----:|:------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.7% | [0.3%, 1.5%] | 26    |
| Regressions ❌ <br /> (secondary)  | 1.1% | [0.2%, 1.9%] | 21    |
| Improvements ✅ <br /> (primary)   | -    | -            | 0     |
| Improvements ✅ <br /> (secondary) | -    | -            | 0     |
| All ❌✅ (primary)                 | 0.7% | [0.3%, 1.5%] | 26    |

[Another rewrite](https://github.com/rust-lang/rust/pull/113316) is pending
which is expected to help resolve the regression.

#### Improvements

A mish-mash of micro-optimizations [#113116](https://github.com/rust-lang/rust/pull/113116) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=330727467b8fdf2c43b95095a0efae7012c4f83b&end=8aed93d912ec23819c08e9a89ca1fb461b3cd2e6&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -     | -              | 0     |
| Regressions ❌ <br /> (secondary)  | -     | -              | 0     |
| Improvements ✅ <br /> (primary)   | -0.8% | [-1.7%, -0.3%] | 16    |
| Improvements ✅ <br /> (secondary) | -1.4% | [-2.3%, -0.8%] | 15    |
| All ❌✅ (primary)                 | -0.8% | [-1.7%, -0.3%] | 16    |


Make simd_shuffle_indices use valtrees [#112718](https://github.com/rust-lang/rust/pull/112718) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=be6e38c617d39b3b1e9ac8a3fe606cb5d72ca6af&end=72b21014344fe5a595270c951d5a15887f9c7992&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -     | -              | 0     |
| Regressions ❌ <br /> (secondary)  | -     | -              | 0     |
| Improvements ✅ <br /> (primary)   | -0.4% | [-0.5%, -0.4%] | 3     |
| Improvements ✅ <br /> (secondary) | -     | -              | 0     |
| All ❌✅ (primary)                 | -0.4% | [-0.5%, -0.4%] | 3     |


cargo update [#113046](https://github.com/rust-lang/rust/pull/113046) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=bf0e22b298e282dec3589f70c67e401588d6c693&end=839e9a6e1210934fd24b15548b811a97c77138fc&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -     | -              | 0     |
| Regressions ❌ <br /> (secondary)  | -     | -              | 0     |
| Improvements ✅ <br /> (primary)   | -1.1% | [-2.0%, -0.4%] | 119   |
| Improvements ✅ <br /> (secondary) | -0.9% | [-1.6%, -0.2%] | 48    |
| All ❌✅ (primary)                 | -1.1% | [-2.0%, -0.4%] | 119   |


#### Mixed

Refactor metadata emission to avoid visiting HIR [#98867](https://github.com/rust-lang/rust/pull/98867) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=eb76764ea412b36f670564f5d58c317cec8fa496&end=5bd28f5eac1ba3569bfa8d49ec3f5acbdfdff7a0&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.8%  | [0.5%, 0.9%]   | 7     |
| Regressions ❌ <br /> (secondary)  | 1.0%  | [0.2%, 2.3%]   | 19    |
| Improvements ✅ <br /> (primary)   | -2.1% | [-3.9%, -0.8%] | 6     |
| Improvements ✅ <br /> (secondary) | -4.4% | [-7.2%, -1.5%] | 2     |
| All ❌✅ (primary)                 | -0.5% | [-3.9%, 0.9%]  | 13    |


Upgrade to indexmap 2.0.0 [#113304](https://github.com/rust-lang/rust/pull/113304) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=0130c3a06e50ebb166655f81997ce28b9e4029b0&end=52d8c490a3aabe65cdd9f2d3aed95034dd5dbad7&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.8%  | [0.4%, 1.2%]   | 20    |
| Regressions ❌ <br /> (secondary)  | 0.7%  | [0.3%, 1.2%]   | 16    |
| Improvements ✅ <br /> (primary)   | -     | -              | 0     |
| Improvements ✅ <br /> (secondary) | -0.6% | [-0.6%, -0.5%] | 4     |
| All ❌✅ (primary)                 | 0.8%  | [0.4%, 1.2%]   | 20    |
